/*
 * Arduino Workbench tekyinblack 2020 - www.tekyinblack.com
 */
/*
 * setupTouch - run setup routines for touchscreen
 * registerTouch - add item touch information to main workScreens array
 * updateTouch - if screen touched, locate item and take action based on item touched
 * logicTouch - packages touch co-ordinated into structure
 * logicScreenPress - hardware based mapping of touch event
 */
void setupTouch() {
   
}
void registerTouch(int itemNo, struct touchInfo touchReg) {
  // routine to register object drawn on screen as eligible for touch input
  workScreens[itemNo][ITEMTX1] = touchReg.xinfo1; 
  workScreens[itemNo][ITEMTX2] = touchReg.xinfo2; 
  workScreens[itemNo][ITEMTY1] = touchReg.yinfo1; 
  workScreens[itemNo][ITEMTY2] = touchReg.yinfo2; 
}
void updateTouch(void) {
  
  logicScreenPress();
  
  for (int i=0; i < itemCount; i++) {
    if (workScreens[i][ELIGIBLE] == 1) {
      if (workScreens[i][ITEMTX1] > xpos) {
        continue;
        }
      if (workScreens[i][ITEMTX2] < xpos) {
        continue;
        }
      if (workScreens[i][ITEMTY1] > ypos) {
        continue;
        }
      if (workScreens[i][ITEMTY2] > ypos) {
        workScreens[i][ITEM_TOUCH] = 1;
        itemTouched=i;
        break;
        }
      }
    }

  if (itemTouched != 999) {  
       if (workScreens[itemTouched][ITEMTYPE] == MENU_BOX) {
           switch (workScreens[itemTouched][MENU_ACTION]) {
            case 1:
            // display selection menu
            break;
            case 2:
            // normal display
            drawNormalScreen();
            break;
            case 3:
            // large display
            drawLargeScreen();
            break;
            case 4:
            // full screen display
            drawFullScreen();
            break;
           }
         } else {
          itemTouchedPrev = itemTouched;
          itemTouchTimer = millis() + ITEM_TOUCH_TIMEOUT;
         }
    }
}

struct touchInfo logicTouch(int xTouch1, int xTouch2, int yTouch1, int yTouch2) {
  // routine to register object drawn on screen as eligible for touch input
  struct touchInfo tempTouch;
    tempTouch.xinfo1 = xTouch1;
    tempTouch.xinfo2 = xTouch2;
    tempTouch.yinfo1 = yTouch1;
    tempTouch.yinfo2 = yTouch2;
    return tempTouch; 
}


void logicScreenPress(void) {
  // most mcufriend have touch (with icons) that extends below the TFT
  // screens without icons need to reserve a space for "erase"
  // scale the ADC values from ts.getPoint() to screen values e.g. 0-239
  //
  // Calibration is true for PORTRAIT. tp.y is always long dimension 
  // map to your current pixel orientation
  switch (Orientation) {
      case 0:
          xpos = map(tp.x, TS_LEFT, TS_RT, 0, tft.width());
          ypos = map(tp.y, TS_TOP, TS_BOT, 0, tft.height());
          break;
      case 1:
          xpos = map(tp.y, TS_TOP, TS_BOT, 0, tft.width());
          ypos = map(tp.x, TS_RT, TS_LEFT, 0, tft.height());
          break;
      case 2:
          xpos = map(tp.x, TS_RT, TS_LEFT, 0, tft.width());
          ypos = map(tp.y, TS_BOT, TS_TOP, 0, tft.height());
          break;
      case 3:
          xpos = map(tp.y, TS_BOT, TS_TOP, 0, tft.width());
          ypos = map(tp.y, TS_LEFT, TS_RT, 0, tft.height());
          break;
  }
}
